---
# defaults file for victoriametrics
victoriametrics_volume_root: "{{ volume_root_dir }}/victoriametrics"
graphana_volume_root: "{{ volume_root_dir }}/graphana"

vmagent:
  container_name: vmagent
  app_name: vmagent
  image: victoriametrics/vmagent:v1.93.4
  ports:
    - 8429:8429
  volumes:
    - "{{ volume_root_dir }}/vmagent/vmagentdata:/vmagentdata"
    - "{{ volume_root_dir }}/vmagent/prometheus.yml:/etc/prometheus/prometheus.yml"
  command:
    - "--promscrape.config=/etc/prometheus/prometheus.yml"
    - "--remoteWrite.url=http://victoriametrics:8428/api/v1/write"
  networks:
    - vm_net


victoriametrics:
  container_name: victoriametrics
  image: victoriametrics/victoria-metrics:v1.93.4
  ports:
    - "8428:8428"
    - "18089:8089"
    - "8089:8089/udp"
    - "2003:2003"
    - "2003:2003/udp"
    - "4242:4242"
  # expose:
  #   - "8428-18428"
  #   - "8089-18089"
  #   - "2003-12003"
  #   - "4242-14242"
  volumes:
    - "{{ victoriametrics_volume_root }}/vmdata:/storage:Z,U,rbind,noexec"
  command:
    - "--storageDataPath=/storage"
    - "--graphiteListenAddr=:2003"
    - "--opentsdbListenAddr=:4242"
    - "--httpListenAddr=:8428"
    - "--influxListenAddr=:8089"
    - "--vmalert.proxyURL=http://vmalert:8880"
  networks:
    - vm_net

grafana:
  container_name: grafana
  app_name: grafana
  image: grafana/grafana:9.2.7
  ports:
    - 3000:3000
  volumes:
    - '{{ volume_root_dir }}/grafana/grafanadata:/var/lib/grafana'
    - '{{ volume_root_dir }}/grafana/provisioning:/etc/grafana/provisioning'
    - '{{ volume_root_dir }}/grafana/dashboards/vm/victoriametrics.json:/var/lib/grafana/dashboards/vm.json'
    - '{{ volume_root_dir }}/grafana/dashboards/vm/vmalert.json:/var/lib/grafana/dashboards/vmalert.json'
    - '{{ volume_root_dir }}/grafana/dashboards/vm/vmagent.json:/var/lib/grafana/dashboards/vmagent.json'
    - '{{ volume_root_dir }}/grafana/dashboards/victorialogs.json:/var/lib/grafana/dashboards/vl.json'
  networks:
    - vm_net

vmalert:
  container_name: vmalert
  image: victoriametrics/vmalert:v1.93.4
  depends_on:
    - "victoriametrics"
    - "alertmanager"
  ports:
    - 8880:8880
  volumes:
    - ./alerts.yml:/etc/alerts/alerts.yml
    - ./alerts-health.yml:/etc/alerts/alerts-health.yml
    - ./alerts-vmagent.yml:/etc/alerts/alerts-vmagent.yml
    - ./alerts-vmalert.yml:/etc/alerts/alerts-vmalert.yml
  command:
    - "--datasource.url=http://victoriametrics:8428/"
    - "--remoteRead.url=http://victoriametrics:8428/"
    - "--remoteWrite.url=http://victoriametrics:8428/"
    - "--notifier.url=http://alertmanager:9093/"
    - "--rule=/etc/alerts/*.yml"
    # display source of alerts in grafana
    - "--external.url=http://127.0.0.1:3000" #grafana outside container
    # when copypaste the line be aware of '$$' for escaping in '$expr'
    - '--external.alert.source=explore?orgId=1&left={"datasource":"VictoriaMetrics","queries":[{"expr":{{$$expr|jsonEscape|queryEscape}},"refId":"A"}],"range":{"from":"now-1h","to":"now"}}'
  networks:
    - vm_net
  restart: always

alertmanager:
  container_name: alertmanager
  image: prom/alertmanager:v0.25.0
  volumes:
    - ./alertmanager.yml:/config/alertmanager.yml
  command:
    - "--config.file=/config/alertmanager.yml"
  ports:
    - 9093:9093
  networks:
    - vm_net
  restart: always

fluentbit:
  container_name: fluentbit
  image: cr.fluentbit.io/fluent/fluent-bit:2.1.4
  volumes:
    - /var/lib/docker/containers:/var/lib/docker/containers:ro
    - ./fluent-bit.conf:/fluent-bit/etc/fluent-bit.conf
  depends_on: [victorialogs]
  ports:
    - "5140:5140"
  networks:
    - vm_net

victorialogs:
  container_name: victorialogs
  image: docker.io/victoriametrics/victoria-logs:v0.3.0-victorialogs
  command:
    - "--storageDataPath=/vlogs"
    - "--httpListenAddr=:9428"
  volumes:
    - victorialogs-fluentbit:/vlogs
  ports:
    - "9428:9428"
  networks:
    - vm_net


services:
  - app_name: vmagent
    container_name: vmagent
    image: victoriametrics/vmagent:v1.94.0
    depends_on:
      - "victoriametrics"
    ports:
      - 8429:8429
    volumes:
      - vmagentdata:/vmagentdata
      - prometheus.yml:/etc/prometheus/prometheus.yml
    command:
      - "--promscrape.config=/etc/prometheus/prometheus.yml"
      - "--remoteWrite.url=http://victoriametrics:8428/api/v1/write"
    networks:
      - vm_net
    restart: always
  - app_name: victoriametrics
    container_name: victoriametrics
    image: victoriametrics/victoria-metrics:v1.94.0
    ports:
      - 8428:8428
      - 8089:8089
      - 8089:8089/udp
      - 2003:2003
      - 2003:2003/udp
      - 4242:4242
    volumes:
      - vmdata:/storage
    command:
      - "--storageDataPath=/storage"
      - "--graphiteListenAddr=:2003"
      - "--opentsdbListenAddr=:4242"
      - "--httpListenAddr=:8428"
      - "--influxListenAddr=:8089"
      - "--vmalert.proxyURL=http://vmalert:8880"
    networks:
      - vm_net
    restart: always
  - app_name: grafana
    container_name: grafana
    image: grafana/grafana:9.2.7
    depends_on:
      - "victoriametrics"
    ports:
      - 3000:3000
    volumes:
      - grafanadata:/var/lib/grafana
      - ./provisioning/:/etc/grafana/provisioning/
      - ./../../dashboards/victoriametrics.json:/var/lib/grafana/dashboards/vm.json
      - ./../../dashboards/victorialogs.json:/var/lib/grafana/dashboards/vl.json
      - ./../../dashboards/vmagent.json:/var/lib/grafana/dashboards/vmagent.json
      - ./../../dashboards/vmalert.json:/var/lib/grafana/dashboards/vmalert.json
    networks:
      - vm_net
    restart: always
  - app_name: vmalert
    container_name: vmalert
    image: victoriametrics/vmalert:v1.94.0
    depends_on:
      - "victoriametrics"
      - "alertmanager"
    ports:
      - 8880:8880
    volumes:
      - ./alerts.yml:/etc/alerts/alerts.yml
      - ./alerts-health.yml:/etc/alerts/alerts-health.yml
      - ./alerts-vmagent.yml:/etc/alerts/alerts-vmagent.yml
      - ./alerts-vmalert.yml:/etc/alerts/alerts-vmalert.yml
    command:
      - "--datasource.url=http://victoriametrics:8428/"
      - "--remoteRead.url=http://victoriametrics:8428/"
      - "--remoteWrite.url=http://victoriametrics:8428/"
      - "--notifier.url=http://alertmanager:9093/"
      - "--rule=/etc/alerts/*.yml"
      # display source of alerts in grafana
      - "--external.url=http://127.0.0.1:3000" #grafana outside container
      # when copypaste the line be aware of '$$' for escaping in '$expr'
      - '--external.alert.source=explore?orgId=1&left={"datasource":"VictoriaMetrics","queries":[{"expr":{{$$expr|jsonEscape|queryEscape}},"refId":"A"}],"range":{"from":"now-1h","to":"now"}}'
    networks:
      - vm_net
    restart: always
  - app_name: alertmanager
    container_name: alertmanager
    image: prom/alertmanager:v0.25.0
    volumes:
      - ./alertmanager.yml:/config/alertmanager.yml
    command:
      - "--config.file=/config/alertmanager.yml"
    ports:
      - 9093:9093
    networks:
      - vm_net
    restart: always
  - app_name: fluentbit
    container_name: fluentbit
    image: cr.fluentbit.io/fluent/fluent-bit:2.1.4
    volumes:
      - /var/lib/docker/containers:/var/lib/docker/containers:ro
      - ./fluent-bit.conf:/fluent-bit/etc/fluent-bit.conf
    depends_on: [victorialogs]
    ports:
      - "5140:5140"
    networks:
      - vm_net
  - app_name: victorialogs
    container_name: victorialogs
    image: docker.io/victoriametrics/victoria-logs:v0.4.1-victorialogs
    command:
      - "--storageDataPath=/vlogs"
      - "--httpListenAddr=:9428"
    volumes:
      - victorialogs-fluentbit:/vlogs
    ports:
      - "9428:9428"
    networks:
      - vm_net
